/*
 * DesktopApplication1View.java
 */

package br.com.topologica.view;

import br.com.topologica.*;
import br.com.topologica.map.MapClipper;
import br.com.topologica.map.SPBMetro;
import br.com.topologica.task.VehicleTask;
import br.com.topologica.vo.Departamento;
import br.com.topologica.vo.Dominio;
import br.com.topologica.vo.Empresa;
import br.com.topologica.vo.Vehicle;
import com.thoughtworks.xstream.XStream;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Point2D;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.SimpleDoc;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.Copies;
import javax.print.attribute.standard.JobName;
import javax.print.attribute.standard.OrientationRequested;
import javax.swing.Icon;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.jdesktop.application.Task;
import org.jdesktop.application.TaskMonitor;
import org.jdic.web.BrMap;
import org.jdic.web.BrMapMousePos;
import javax.swing.Timer;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import org.jdesktop.application.ApplicationContext;
import org.jdesktop.beansbinding.BindingGroup;

/**
 * The application's main frame.
 */
public class MainContainerView extends FrameView {

    private VehicleTask myTask;

    private MapClipper brMap;
    org.jdic.web.BrMapOver brMapBack;

    
    private List<Vehicle> listVehicles;

    private Dominio domain;

    public List<Vehicle> getListVehicles() {
        return listVehicles;
    }

    public void setListVehicles(List<Vehicle> listVehicles) {
        this.listVehicles = listVehicles;
    }
    
    BindingGroup bindingGroup = new org.jdesktop.beansbinding.BindingGroup();
    
    
    public MapPanelView getMapPanel1() {
        return mapPanel1;
    }

    public void setMapPanel1(MapPanelView mapPanel1) {
        this.mapPanel1 = mapPanel1;
    }

    public MainContainerView(SingleFrameApplication app)  {
        super(app);
         try {
            UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
            //SwingUtilities.updateComponentTreeUI(DesktopApplication1View.this);
        } catch (InstantiationException ex) {
            Logger.getLogger(MainContainerView.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(MainContainerView.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception ex) {
            Logger.getLogger(MainContainerView.class.getName()).log(Level.SEVERE, null, ex);
        }

        
        listVehicles = org.jdesktop.observablecollections.ObservableCollections.observableList(new Vector<Vehicle>());
        initComponents();
        configBindingJTable();

        

         brMap = (MapClipper) mapPanel1.getBrMap1();
        brMap.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                brMapPropertyChange(evt);
            }
        });

        brMap.setEdAddress(edAddress);
        brMap.setCbSelectWorkingArea(cbSelectWorkingArea);
        brMap.setBtResetSelection(btResetSelection);
        brMap.setEdLat(edLat);
        brMap.setEdLng(edLng);
        brMap.setEdScale(edScale);
        brMap.setCbGrid(cbGrid);
        brMap.setCbInGrade(cbInGrade);

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String)(evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer)(evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }
        });

        UIManager.LookAndFeelInfo[] LFs = UIManager.getInstalledLookAndFeels();
        for (int i = 0; i < LFs.length; i++) {
            System.out.println(LFs[i].getClassName());
        }

        this.getFrame().setBounds(-1, -1, 1024, 768);
        // SwingUtilities.updateComponentTreeUI(this);
    }

   

    public void loadXmlConfiguration(File file) {

            XStream xstream = new XStream();
            xstream.autodetectAnnotations(true);
             file = new File("C:\\Users\\Shalmany\\Documents\\NetBeansProjects\\VideoMonMobile\\src\\config.xml");
            xstream.alias("dominio", Dominio.class);


        try {
            domain = (Dominio) xstream.fromXML(new FileInputStream(file));
            DefaultMutableTreeNode nodeRoot =   new DefaultMutableTreeNode(domain.getPais());
            List<Empresa> listEmpresas =  domain.getEmpresas();
           for (Empresa empresa : listEmpresas) {
                    DefaultMutableTreeNode  nodeCompany = new DefaultMutableTreeNode(empresa.getId());
                    List<Departamento> listDepartamentos =  empresa.getDepartamentos();
                    for (Departamento departamento : listDepartamentos) {
                       DefaultMutableTreeNode  nodeDepartamento = new DefaultMutableTreeNode(departamento.getId());
                       List<Vehicle> listVehiclesAux =  departamento.getVehicles();
                        for (Vehicle vehicle : listVehiclesAux) {
                            DefaultMutableTreeNode  nodeVehicle = new DefaultMutableTreeNode(vehicle);
                            nodeDepartamento.add(nodeVehicle);
                            this.listVehicles.add(vehicle);
                        }
                        nodeCompany.add(nodeDepartamento);
                    }

                     nodeRoot.add(nodeCompany);
           }

           domainVehiclesTree1.createTreeDomain(new DefaultTreeModel(nodeRoot));
           
           //listVehicles
           for (int i = 0; i < listVehicles.size(); i++) {
                Vehicle vehicle = listVehicles.get(i);
                            VehicleTask myTask = new VehicleTask(VideoMonMobile.getApplication());
                        myTask.setVehicle(vehicle);
       
                            myTask.execute();

                        Thread.sleep(500);
                        //break;
                        
             }

        } catch (Exception ex) {
            Logger.getLogger(MainContainerView.class.getName()).log(Level.SEVERE, null, ex);
        }
       
    }

    private void loadConfig(java.awt.event.ActionEvent evt) {

       evt.getActionCommand();
       if(JFileChooser.APPROVE_SELECTION.equals(evt.getActionCommand())){
         JFileChooser jFileChooser =(JFileChooser) evt.getSource();
//         jFileChooser.setActionMap(am)
          final File file =jFileChooser.getSelectedFile();
           Thread thread = new Thread(){
               public void run(){
                loadXmlConfiguration(file);
               }
           };
           thread.start();
       }
    }
    private void configBindingJTable() {
        //listVehicles = java.beans.Beans.isDesignTime() ? java.util.Collections.emptyList() : customerQuery.getResultList();
org.jdesktop.swingbinding.JTableBinding jTableBinding = org.jdesktop.swingbinding.SwingBindings.createJTableBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, listVehicles, jTable1);
        org.jdesktop.swingbinding.JTableBinding.ColumnBinding columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${id}"));
        columnBinding.setColumnName("Veículo");
        columnBinding.setColumnClass(String.class);

        

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${dateFormat}"));
        columnBinding.setColumnName("Data-Hora");
        columnBinding.setColumnClass(String.class);

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${altitude}"));
        columnBinding.setColumnName("Altitude");
        columnBinding.setColumnClass(String.class);

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${latitude}"));
        columnBinding.setColumnName("Latitude");
        columnBinding.setColumnClass(Double.class);

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${longitude}"));
        columnBinding.setColumnName("Longitude");
        columnBinding.setColumnClass(Double.class);

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${placa}"));
        columnBinding.setColumnName("Placa");
        columnBinding.setColumnClass(String.class);

        

        columnBinding = jTableBinding.addColumnBinding(org.jdesktop.beansbinding.ELProperty.create("${speed}"));
        columnBinding.setColumnName("Velocidade");
        columnBinding.setColumnClass(Double.class);

        bindingGroup.addBinding(jTableBinding);
        jTableBinding.bind();
bindingGroup.bind();
    }

     private void setSaveNeeded(boolean saveNeeded) {
        System.out.println("tetse");
    }
    private void brMapPropertyChange(java.beans.PropertyChangeEvent evt) {
        String stPN = evt.getPropertyName();
        if (stPN.equals("securityIcon") || stPN.equals("navigatedURL") || stPN.equals("progressBar")) {
            String stNV = (String) evt.getNewValue();
            if (null == stNV) {
                stNV = "";
            }
            String st[] = stNV.split(",");
            /*
            if(stPN.equals("navigatedURL")) {
            edAddress.setText( st[0] );
            stOldParams = "";
            brXMLTree.empty();
            } else*/ if (stPN.equals("progressBar")) {
                int iMax = Integer.parseInt(st[0]),
                        iPos = Integer.parseInt(st[1]);
                if (0 == iMax) {
                    progressBar.setVisible(false);
                } else {
                    progressBar.setMaximum(iMax);
                    progressBar.setValue(iPos);
                    progressBar.setVisible(true);
                }
            } /*else if(stPN.equals("securityIcon")) {
        bnLocker.setVisible(!stNV.equals("0"));
        } */
        } else if (stPN.equals("mouseGeoPos")) {
            Point2D gp = ((BrMapMousePos) evt.getNewValue()).getMouseGeoPos();
            Double Latitude = gp.getX();
            Double Longitude = gp.getY();
            edLat.setText(cbInGrade.isSelected() ? BrMap.getGrade(Latitude, BrMap.LAT) : ("" + Latitude));
            edLng.setText(cbInGrade.isSelected() ? BrMap.getGrade(Longitude, BrMap.LNG) : ("" + Longitude));
        }
  

    }

     @Action
    public Task showTest() {
         cancelTest();
         myTask = new VehicleTask(VideoMonMobile.getApplication());
         myTask.setBrmap(mapPanel1.getBrMap1());
        return null;
    }


       @Action
    public void cancelTest() {
//        if ((myTask != null) && !myTask.isDone()) {
//            myTask.cancel(true);
//            }
    }

   

    

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = VideoMonMobile.getApplication().getMainFrame();
            aboutBox = new VideoMonMobileAboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        VideoMonMobile.getApplication().show(aboutBox);
    }

    public void showOpenFileconfiguration(){

           JFrame mainFrame = VideoMonMobile.getApplication().getMainFrame();
            JFileChooser jFileChooser = new JFileChooser();

            jFileChooser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadConfig(evt);
            }
        });
            jFileChooser.showOpenDialog(mainFrame);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        mapPanel1 = new br.com.topologica.view.MapPanelView();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jSplitPane3 = new javax.swing.JSplitPane();
        domainVehiclesTree1 = new br.com.topologica.view.DomainVehiclesTreeView();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        tbArea = new javax.swing.JToolBar();
        cbSelectWorkingArea = new javax.swing.JToggleButton();
        btResetSelection = new javax.swing.JButton();
        tbMetro = new javax.swing.JToggleButton();
        tbComposite = new javax.swing.JToggleButton();
        lbAddress = new javax.swing.JLabel();
        edAddress = new javax.swing.JTextField();
        bnGo = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        fileMenu = new javax.swing.JMenu();
        miOpen = new javax.swing.JMenuItem();
        miSave = new javax.swing.JMenuItem();
        miOZIExport = new javax.swing.JMenuItem();
        miPrint = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        miExit = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();
        lbLat = new javax.swing.JLabel();
        edLat = new javax.swing.JTextField();
        lbLng = new javax.swing.JLabel();
        edLng = new javax.swing.JTextField();
        cbInGrade = new javax.swing.JCheckBox();
        cbGrid = new javax.swing.JCheckBox();
        edScale = new javax.swing.JTextField();
        lbMeter = new javax.swing.JLabel();
       

        mainPanel.setMaximumSize(new java.awt.Dimension(700, 600));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(700, 639));
        mainPanel.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setName("jSplitPane1"); // NOI18N

        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setName("jSplitPane2"); // NOI18N

        mapPanel1.setName("mapPanel1"); // NOI18N
        jSplitPane2.setLeftComponent(mapPanel1);

        jTabbedPane2.setName("jTabbedPane2"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jTable1.setName("jTable1"); // NOI18N
        jScrollPane1.setViewportView(jTable1);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(br.com.topologica.VideoMonMobile.class).getContext().getResourceMap(MainContainerView.class);
        jTabbedPane2.addTab(resourceMap.getString("jScrollPane1.TabConstraints.tabTitle"), jScrollPane1); // NOI18N

        jSplitPane2.setRightComponent(jTabbedPane2);
        jTabbedPane2.getAccessibleContext().setAccessibleName(resourceMap.getString("jTabbedPane2.AccessibleContext.accessibleName")); // NOI18N

        jSplitPane1.setRightComponent(jSplitPane2);

        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane3.setName("jSplitPane3"); // NOI18N

        domainVehiclesTree1.setName("domainVehiclesTree1"); // NOI18N
        domainVehiclesTree1.setPreferredSize(new java.awt.Dimension(100, 200));
        jSplitPane3.setLeftComponent(domainVehiclesTree1);

        jTabbedPane1.setName("jTabbedPane1"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel1.TabConstraints.tabTitle"), jPanel1); // NOI18N

        jSplitPane3.setRightComponent(jTabbedPane1);

        jSplitPane1.setLeftComponent(jSplitPane3);

        mainPanel.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        tbArea.setRollover(true);
        tbArea.setMaximumSize(new java.awt.Dimension(506, 27));
        tbArea.setName("Map Working Area Setup"); // NOI18N

        cbSelectWorkingArea.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/sel_zoom.png"))); // NOI18N
        cbSelectWorkingArea.setFocusable(false);
        cbSelectWorkingArea.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        cbSelectWorkingArea.setMargin(new java.awt.Insets(0, 0, 0, 0));
        cbSelectWorkingArea.setName("cbSelectWorkingArea"); // NOI18N
        cbSelectWorkingArea.setSelectedIcon(new javax.swing.ImageIcon(getClass().getResource("/images/sel_area.png"))); // NOI18N
        cbSelectWorkingArea.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbSelectWorkingAreaActionPerformed(evt);
            }
        });
        tbArea.add(cbSelectWorkingArea);

        btResetSelection.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/sel_auto.png"))); // NOI18N
        btResetSelection.setEnabled(false);
        btResetSelection.setFocusable(false);
        btResetSelection.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btResetSelection.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btResetSelection.setMaximumSize(null);
        btResetSelection.setMinimumSize(null);
        btResetSelection.setName("btResetSelection"); // NOI18N
        btResetSelection.setPreferredSize(null);
        btResetSelection.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btResetSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btResetSelectionActionPerformed(evt);
            }
        });
        tbArea.add(btResetSelection);

        tbMetro.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/metro.png"))); // NOI18N
        tbMetro.setFocusable(false);
        tbMetro.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        tbMetro.setMargin(new java.awt.Insets(0, 0, 0, 0));
        tbMetro.setName("tbMetro"); // NOI18N
        tbMetro.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbMetro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tbMetroActionPerformed(evt);
            }
        });
        tbArea.add(tbMetro);

        tbComposite.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/mapover.png"))); // NOI18N
        tbComposite.setFocusable(false);
        tbComposite.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        tbComposite.setMargin(new java.awt.Insets(0, 0, 0, 0));
        tbComposite.setName("tbComposite"); // NOI18N
        tbComposite.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        tbComposite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tbCompositeActionPerformed(evt);
            }
        });
        tbArea.add(tbComposite);

        lbAddress.setText(resourceMap.getString("lbAddress.text")); // NOI18N
        lbAddress.setName("lbAddress"); // NOI18N
        tbArea.add(lbAddress);

        edAddress.setText(resourceMap.getString("edAddress.text")); // NOI18N
        edAddress.setName("edAddress"); // NOI18N
        edAddress.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                edAddressMouseClicked(evt);
            }
        });
        edAddress.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                edAddressActionPerformed(evt);
            }
        });
        edAddress.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                edAddressKeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                edAddressKeyTyped(evt);
            }
        });
        tbArea.add(edAddress);

        bnGo.setText(resourceMap.getString("bnGo.text")); // NOI18N
        bnGo.setFocusable(false);
        bnGo.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        bnGo.setName("bnGo"); // NOI18N
        bnGo.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        bnGo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnGoActionPerformed(evt);
            }
        });
        tbArea.add(bnGo);

        mainPanel.add(tbArea, java.awt.BorderLayout.PAGE_START);

        menuBar.setName("menuBar"); // NOI18N

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(br.com.topologica.VideoMonMobile.class).getContext().getActionMap(MainContainerView.class, this);
        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setToolTipText(resourceMap.getString("fileMenu.toolTipText")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        miOpen.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        miOpen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/open.png"))); // NOI18N
        miOpen.setText(resourceMap.getString("miOpen.text")); // NOI18N
        miOpen.setToolTipText(resourceMap.getString("miOpen.toolTipText")); // NOI18N
        miOpen.setName("miOpen"); // NOI18N
        miOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miOpenActionPerformed(evt);
            }
        });
        fileMenu.add(miOpen);

        miSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        miSave.setText(resourceMap.getString("miSave.text")); // NOI18N
        miSave.setToolTipText(resourceMap.getString("miSave.toolTipText")); // NOI18N
        miSave.setName("miSave"); // NOI18N
        miSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miSaveActionPerformed(evt);
            }
        });
        fileMenu.add(miSave);

        miOZIExport.setText(resourceMap.getString("miOZIExport.text")); // NOI18N
        miOZIExport.setToolTipText(resourceMap.getString("miOZIExport.toolTipText")); // NOI18N
        miOZIExport.setName("miOZIExport"); // NOI18N
        miOZIExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miOZIExportActionPerformed(evt);
            }
        });
        fileMenu.add(miOZIExport);

        miPrint.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        miPrint.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/print.png"))); // NOI18N
        miPrint.setText(resourceMap.getString("miPrint.text")); // NOI18N
        miPrint.setToolTipText(resourceMap.getString("miPrint.toolTipText")); // NOI18N
        miPrint.setName("miPrint"); // NOI18N
        miPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miPrintActionPerformed(evt);
            }
        });
        fileMenu.add(miPrint);

        jSeparator3.setName("jSeparator3"); // NOI18N
        fileMenu.add(jSeparator3);

        miExit.setText(resourceMap.getString("miExit.text")); // NOI18N
        miExit.setName("miExit"); // NOI18N
        miExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miExitActionPerformed(evt);
            }
        });
        fileMenu.add(miExit);

        menuBar.add(fileMenu);

        statusPanel.setName("statusPanel"); // NOI18N
        statusPanel.setPreferredSize(new java.awt.Dimension(700, 27));

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        lbLat.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lbLat.setText(resourceMap.getString("lbLat.text")); // NOI18N
        lbLat.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        lbLat.setName("lbLat"); // NOI18N

        edLat.setName("edLat"); // NOI18N

        lbLng.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lbLng.setText(resourceMap.getString("lbLng.text")); // NOI18N
        lbLng.setName("lbLng"); // NOI18N

        edLng.setName("edLng"); // NOI18N

        cbInGrade.setSelected(true);
        cbInGrade.setText(resourceMap.getString("cbInGrade.text")); // NOI18N
        cbInGrade.setFocusable(false);
        cbInGrade.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        cbInGrade.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        cbInGrade.setName("cbInGrade"); // NOI18N
        cbInGrade.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbInGradeActionPerformed(evt);
            }
        });

        cbGrid.setText(resourceMap.getString("cbGrid.text")); // NOI18N
        cbGrid.setName("cbGrid"); // NOI18N
        cbGrid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbGridActionPerformed(evt);
            }
        });

        edScale.setText(resourceMap.getString("edScale.text")); // NOI18N
        edScale.setName("edScale"); // NOI18N

        lbMeter.setText(resourceMap.getString("lbMeter.text")); // NOI18N
        lbMeter.setName("lbMeter"); // NOI18N

        javax.swing.GroupLayout statusPanelLayout = new javax.swing.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusMessageLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbLat, javax.swing.GroupLayout.PREFERRED_SIZE, 52, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edLat, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbLng, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edLng, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cbInGrade)
                .addGap(24, 24, 24)
                .addComponent(cbGrid)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(edScale, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbMeter, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(statusPanelLayout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusMessageLabel)
                    .addComponent(statusAnimationLabel))
                .addGap(3, 3, 3))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, statusPanelLayout.createSequentialGroup()
                .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(statusPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(progressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(statusPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(lbLat, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addComponent(edLat, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addComponent(edLng, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addComponent(lbLng, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addComponent(cbInGrade, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(cbGrid, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(edScale, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addComponent(lbMeter, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)))
                .addContainerGap())
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
    }// </editor-fold>//GEN-END:initComponents

    private void cbInGradeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbInGradeActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_cbInGradeActionPerformed

    private void cbGridActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbGridActionPerformed
        // TODO add your handling code here
        mapPanel1.getBrMap1().repaint();
    }//GEN-LAST:event_cbGridActionPerformed

    

    private void cbSelectWorkingAreaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbSelectWorkingAreaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_cbSelectWorkingAreaActionPerformed

//GEN-FIRST:event_bnGoActionPerformed

//GEN-LAST:event_bnGoActionPerformed

private void btResetSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btResetSelectionActionPerformed
((MapClipper) brMap).bAutoArea = true;
    ((MapClipper) brMap).rcArea = new Rectangle(
            68, 32,
            ((MapClipper) brMap).getWidth() - 68 - 2, ((MapClipper) brMap).getHeight() - 32 - 28);
    if (null != brMapBack) {
        brMapBack.setBounds(((MapClipper) brMap).rcArea);
    }
    ((MapClipper) brMap).repaint();
    btResetSelection.setEnabled(false);    // TODO add your handling code here:
}//GEN-LAST:event_btResetSelectionActionPerformed

private void tbMetroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tbMetroActionPerformed
    // TODO add your handling code here:
        brMap.getSprites().clear();
    if (tbMetro.isSelected()) {
        
        SPBMetro mt = new SPBMetro();
        mt.add(brMap);
    }
    brMap.repaint();
}//GEN-LAST:event_tbMetroActionPerformed

private void tbCompositeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tbCompositeActionPerformed
    // TODO add your handling code here:
     if (tbComposite.isSelected()) {
        brMapBack = new org.jdic.web.BrMapOver();
        brMapBack.setMapProvider(brMap.getMapProvider());
        brMapBack.setSyncMap(brMap);
        brMapBack.bnZoomMinus.setVisible(false);
        brMapBack.bnZoomPlus.setVisible(false);
        brMapBack.sbZoomLevel.setVisible(false);
        brMap.getCentralPanel().add(brMapBack);
        // brMap.setZoomLevel(8);
        //brMap.setViewCenter("-15.763088, -47.872657");
        if (((MapClipper) brMap).bAutoArea) {
            ((MapClipper) brMap).rcArea.width /= 2;
            ((MapClipper) brMap).rcArea.height /= 2;
            ((MapClipper) brMap).bAutoArea = false;
            btResetSelection.setEnabled(true);
        }
        brMapBack.setBounds(((MapClipper) brMap).rcArea);
        brMap.repaint();
    } else {
        brMap.getCentralPanel().remove(brMapBack);
        brMap.validate();
        brMapBack = null;
        brMap.repaint();
    }
}//GEN-LAST:event_tbCompositeActionPerformed

private void bnGoActionPerformed(java.awt.event.ActionEvent evt) {
    if (brMap.isMapReady()) {
        brMap.execJS(":_findAddress(\"" + edAddress.getText().replace("\'", "\\\'") + "\")");
    }
}

private void edAddressActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_edAddressActionPerformed
    // TODO add your handling code here:
    bnGoActionPerformed(evt);
}//GEN-LAST:event_edAddressActionPerformed

private void edAddressKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_edAddressKeyPressed
    // TODO add your handling code here:
}//GEN-LAST:event_edAddressKeyPressed

private void edAddressKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_edAddressKeyTyped
    // TODO add your handling code here:
    edAddress.setBackground(UIManager.getColor("text"));
}//GEN-LAST:event_edAddressKeyTyped

private void edAddressMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_edAddressMouseClicked
    // TODO add your handling code here:
}//GEN-LAST:event_edAddressMouseClicked

private void miOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miOpenActionPerformed
    //brMain.open();
   showOpenFileconfiguration();
        
}//GEN-LAST:event_miOpenActionPerformed

private void miSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miSaveActionPerformed
    //brMain.save();
}//GEN-LAST:event_miSaveActionPerformed

private void miOZIExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miOZIExportActionPerformed
    JFileChooser fc = new JFileChooser();
    FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "Map Files", "bmp");
    fc.setFileFilter(filter);
    if (JFileChooser.APPROVE_OPTION == fc.showDialog(this.getFrame(), "Export As OZI Map")) {
        ((MapClipper) brMap).saveMap(fc.getSelectedFile().getAbsolutePath());
        ((MapClipper) brMap).addBoundAsSprite();
        ((MapClipper) brMap).repaint();
    }
}//GEN-LAST:event_miOZIExportActionPerformed

private void miPrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miPrintActionPerformed
    //brMain.print();
    DocFlavor flavor = DocFlavor.SERVICE_FORMATTED.PRINTABLE;
    PrintRequestAttributeSet aset = new HashPrintRequestAttributeSet();
    aset.add(OrientationRequested.LANDSCAPE);
    aset.add(new Copies(1));
    aset.add(new JobName("Map", null));
    // locate a print service that can handle the request
    PrintService[] services =
            PrintServiceLookup.lookupPrintServices(flavor, aset);
    if (services.length > 0) {
        System.out.println("selected printer " + services[0].getName());
        /// create a print job for the chosen service
        DocPrintJob pj = services[0].createPrintJob();
        try {
            //Create a Doc object to hold the print data.
            Doc doc = new SimpleDoc(brMap, flavor, null);
            //print mapM
            pj.print(doc, aset);
        } catch (PrintException e) {
            System.err.println(e);
        }
    }
}//GEN-LAST:event_miPrintActionPerformed

private void miExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miExitActionPerformed
   // dispose();
}//GEN-LAST:event_miExitActionPerformed

    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JButton bnGo;
    javax.swing.JButton btResetSelection;
    javax.swing.JCheckBox cbGrid;
    javax.swing.JCheckBox cbInGrade;
    javax.swing.JToggleButton cbSelectWorkingArea;
   
    br.com.topologica.view.DomainVehiclesTreeView domainVehiclesTree1;
    javax.swing.JTextField edAddress;
    javax.swing.JTextField edLat;
    javax.swing.JTextField edLng;
    javax.swing.JTextField edScale;
    javax.swing.JMenu fileMenu;
    javax.swing.JPanel jPanel1;
    javax.swing.JScrollPane jScrollPane1;
    javax.swing.JSeparator jSeparator3;
    javax.swing.JSplitPane jSplitPane1;
    javax.swing.JSplitPane jSplitPane2;
    javax.swing.JSplitPane jSplitPane3;
    javax.swing.JTabbedPane jTabbedPane1;
    javax.swing.JTabbedPane jTabbedPane2;
    javax.swing.JTable jTable1;
    javax.swing.JLabel lbAddress;
    javax.swing.JLabel lbLat;
    javax.swing.JLabel lbLng;
    javax.swing.JLabel lbMeter;
    javax.swing.JPanel mainPanel;
    br.com.topologica.view.MapPanelView mapPanel1;
    javax.swing.JMenuBar menuBar;
    javax.swing.JMenuItem miExit;
    javax.swing.JMenuItem miOZIExport;
    javax.swing.JMenuItem miOpen;
    javax.swing.JMenuItem miPrint;
    javax.swing.JMenuItem miSave;
    javax.swing.JProgressBar progressBar;
    javax.persistence.EntityManager samplePUEntityManager;
    javax.swing.JLabel statusAnimationLabel;
    javax.swing.JLabel statusMessageLabel;
    javax.swing.JPanel statusPanel;
    javax.swing.JToolBar tbArea;
    javax.swing.JToggleButton tbComposite;
    javax.swing.JToggleButton tbMetro;
    // End of variables declaration//GEN-END:variables

    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;

    private JDialog aboutBox;
}
